# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section   free

# If you don't want to build with maven, and use straight ant instead,
# give rpmbuild option '--without maven'

%define with_maven %{!?_without_maven:1}%{?_without_maven:0}
%define without_maven %{?_without_maven:1}%{!?_without_maven:0}

Name:           tc-maven-plugin
Version:        1.6.0
Release:        1%{?dist}
Epoch:          0
Summary:        Terracotta Maven Plugin
License:        Terracotta Public License
Group:          Development/Java
URL:            http://forge.terracotta.org/releases/projects/tc-maven-plugin/
Source0:        %{name}-%{version}.tgz
# svn export http://svn.terracotta.org/svn/forge/projects/tc-maven-plugin/tags/release-1.6.0/ tc-maven-plugin-1.6.0
# tar czf ../SOURCES/tc-maven-plugin-1.6.0.tgz tc-maven-plugin-1.6.0/

#Source1:        tc-forge-parent-2.0.pom 
# curl -o tc-forge-parent-2.0.pom http://svn.terracotta.org/svn/forge/projects/forge-parent/tags/release-2.0/pom.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        %{name}-settings.xml

Source4:        tcconfig1-1.0.jar
Source5:        tcconfig2-2.0.jar


BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

BuildArch:      noarch
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7.1
%if %{with_maven}
BuildRequires:  maven2-common-poms
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-ant
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-help
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-remote-resources
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  maven-release
BuildRequires:  cargo-maven2-plugin
BuildRequires:  apache-commons-parent
BuildRequires:  terracotta-license-resource-bundle
BuildRequires:  tim-api
%endif
BuildRequires:  berkeleydb-je4
BuildRequires:  h2database
BuildRequires:  knopflerfish
BuildRequires:  sigar
BuildRequires:  terracotta-dso

Requires:  java >= 0:1.6.0

Requires(post):   jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5

%description
The Maven Plugin for Terracotta provides tight integration 
between Terracotta DSO and Maven. It makes it really easy 
to run and test applications with Terracotta.
For example, using the Maven Plugin, your project can define
the main class to launch, and using a simple maven command, 
can easily launch all of the required Java VMs including the 
Terracotta Server to run and test your clustered project.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q 
cp %{SOURCE3} settings.xml
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml

%build
%if %{with_maven}
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
#mkdir  -p $MAVEN_REPO_LOCAL/org/terracotta/forge/forge-parent/2.0/
#cp %{SOURCE1} $MAVEN_REPO_LOCAL/org/terracotta/forge/forge-parent/2.0/forge-parent-2.0.pom
mkdir external_repo
ln -s %{_javadir} external_repo/JPP
mkdir -p $MAVEN_REPO_LOCAL/org/hyperic/libsigar-x86-linux/1.6.4/
if [ -e %{_libdir}/libsigar-x86-linux.so ]; then
   ln -s %{_libdir}/libsigar-x86-linux.so $MAVEN_REPO_LOCAL/org/hyperic/libsigar-x86-linux/1.6.4/libsigar-x86-linux-1.6.4.so
else
   ln -s /dev/null $MAVEN_REPO_LOCAL/org/hyperic/libsigar-x86-linux/1.6.4/libsigar-x86-linux-1.6.4.so
fi
mkdir -p $MAVEN_REPO_LOCAL/org/hyperic/libsigar-amd64-linux/1.6.4/
if [ -e %{_libdir}/libsigar-amd64-linux.so ]; then
   ln -s %{_libdir}/libsigar-amd64-linux.so $MAVEN_REPO_LOCAL/org/hyperic/libsigar-amd64-linux/1.6.4/libsigar-amd64-linux-1.6.4.so
else
   ln -s /dev/null $MAVEN_REPO_LOCAL/org/hyperic/libsigar-amd64-linux/1.6.4/libsigar-amd64-linux-1.6.4.so
fi
mkdir -p $MAVEN_REPO_LOCAL/org/hyperic/libsigar-universal64-macosx/1.6.4/
ln -s /dev/null $MAVEN_REPO_LOCAL/org/hyperic/libsigar-universal64-macosx/1.6.4/libsigar-universal64-macosx-1.6.4.dylib
mkdir -p $MAVEN_REPO_LOCAL/org/hyperic/libsigar-universal-macosx/1.6.4/
ln -s /dev/null $MAVEN_REPO_LOCAL/org/hyperic/libsigar-universal-macosx/1.6.4/libsigar-universal-macosx-1.6.4.dylib
mkdir -p $MAVEN_REPO_LOCAL/org/hyperic/sigar-x86-winnt/1.6.4/
ln -s /dev/null $MAVEN_REPO_LOCAL/org/hyperic/sigar-x86-winnt/1.6.4/sigar-x86-winnt-1.6.4.lib
mkdir -p $MAVEN_REPO_LOCAL/org/hyperic/sigar-x86-winnt/1.6.4/
ln -s /dev/null $MAVEN_REPO_LOCAL/org/hyperic/sigar-x86-winnt/1.6.4/sigar-x86-winnt-1.6.4.dll
mkdir -p $MAVEN_REPO_LOCAL/org/hyperic/sigar-amd64-winnt/1.6.4/
ln -s /dev/null $MAVEN_REPO_LOCAL/org/hyperic/sigar-amd64-winnt/1.6.4/sigar-amd64-winnt-1.6.4.dll
mkdir -p $MAVEN_REPO_LOCAL/org/hyperic/libsigar-x86-solaris/1.6.4/
ln -s /dev/null $MAVEN_REPO_LOCAL/org/hyperic/libsigar-x86-solaris/1.6.4/libsigar-x86-solaris-1.6.4.so
mkdir -p $MAVEN_REPO_LOCAL/org/hyperic/libsigar-sparc-solaris/1.6.4/
ln -s /dev/null $MAVEN_REPO_LOCAL/org/hyperic/libsigar-sparc-solaris/1.6.4/libsigar-sparc-solaris-1.6.4.so
mkdir -p $MAVEN_REPO_LOCAL/org/hyperic/libsigar-amd64-solaris/1.6.4/
ln -s /dev/null $MAVEN_REPO_LOCAL/org/hyperic/libsigar-amd64-solaris/1.6.4/libsigar-amd64-solaris-1.6.4.so
mkdir -p $MAVEN_REPO_LOCAL/org/terracotta/tcconfig1/1.0/
cp %{SOURCE4} $MAVEN_REPO_LOCAL/org/terracotta/tcconfig1/1.0/tcconfig1-1.0.jar
mkdir -p $MAVEN_REPO_LOCAL/org/terracotta/tcconfig2/2.0/
cp %{SOURCE5} $MAVEN_REPO_LOCAL/org/terracotta/tcconfig2/2.0/tcconfig2-2.0.jar

export M2_SETTINGS=$(pwd)/settings.xml
    mvn-jpp \
        -e \
        -s $M2_SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        ant:ant install javadoc:javadoc
%else
export CLASSPATH=
#export CLASSPATH=$(build-classpath \
#)
CLASSPATH=$CLASSPATH:target/classes:target/test-classes
ant -Dmaven.settings.offline=true -Dbuild.sysclasspath=only jar javadoc
%endif

%install
rm -rf $RPM_BUILD_ROOT
# jars/poms
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

%add_to_maven_depmap org.terracotta.maven.plugins tc-maven-plugin %{version} JPP tc-maven-plugin
install -m 644 pom.xml $RPM_BUILD_ROOT/%{_datadir}/maven2/poms/JPP-tc-maven-plugin.pom
install -m 644 target/tc-maven-plugin-%{version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/tc-maven-plugin-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* \
                    $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post 
%update_maven_depmap

%postun 
%update_maven_depmap

%files 
%defattr(-,root,root,-)
%{_javadir}/*
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%changelog
* Tue Sep 28 2010 Ralph Apel <r.apel at r-apel.de> 0:1.6.0-1
- first release

